-- Turbine Imports..
import "WalmPlugins.WarbandsSlayer.src.Turbine";
import "Turbine.Gameplay";

import "WalmPlugins.WarbandsSlayer.src.UTF";
import "WalmPlugins.WarbandsSlayer.src.WarbandsDialog";
import "WalmPlugins.WarbandsSlayer.src.Saving";
import "WalmPlugins.WarbandsSlayer.src.QuickLauncher";
import "WalmPlugins.WarbandsSlayer.src.MiniMapWindow";

RtmCommand = Turbine.ShellCommand();
Preferences = {};

function RtmCommand:Execute( command, arguments )
	if ( arguments == "?" or arguments == "help" or arguments == "man") then
		Turbine.Shell.WriteLine(RtmCommand:GetHelp());
	elseif ( arguments == "show" ) then		
		OpenPane();	
	elseif ( arguments == "option" or  arguments == "options" ) then		
		local optionDialog = GetConfigurationDialogInstance();
		optionDialog:SetVisible(true);	
	else
		if(warbandsDialog ~= nil) then			
			warbandsDialog:AddCooldown(nil, arguments);	
		end		
	end
end

function RtmCommand:GetHelp()
	return "WarbandsSlayer\nPas d'aide (pas le temps :D)\n";
end

function RtmCommand:GetShortHelp()
	return "TODO.";
end

function SavePreferences()
	function SavePreferencesConfirmation(sender, args)
		--Turbine.Shell.WriteLine(ToUTF8("<rgb=#FF5CCD>Mort aux Troupes de Guerre: Preferences sauvegards</rgb>"));
	end
	DataSave(Turbine.DataScope.Account, "MortAuxTroupesDeGuerre_preferences", Preferences);
	
end

function LoadPreferences()	
	local tmpPreferences = DataLoad(Turbine.DataScope.Account, "MortAuxTroupesDeGuerre_preferences");
	if(tmpPreferences ~= nil) then
		Preferences = tmpPreferences;		
	else
		ReinitPreferences();
	end
end

function ReinitPreferences()
	Preferences = {};
	local width, height = Turbine.UI.Display.GetSize();		
	local width2, height2;
	width2 = width/2 - 765/2;
	height2 = height/3 - 574/2;
	Preferences.main_x = width2;
	Preferences.main_y = height2;
	Preferences.minimap_x = width2;
	Preferences.minimap_y = height2;	
	Preferences.quicklaunch_x = width-250;
	Preferences.quicklaunch_y = 20;
	Preferences.utcResetHour = 9;
	Preferences.canMoveQuickLauncher = true;
	Preferences.defaultOpacity = 60;
	Preferences.debug = false;
	Preferences.autoUpdate = true;
	Preferences.OnUpdate = function()
		-- nihil
	end
end

function OpenPane()
	if(warbandsDialog ~= nil) then
		warbandsDialog:SetVisible(true);
	end
end

LoadPreferences();

optionsPanel = Turbine.UI.Control();
optionsPanel:SetSize(250, 20 );
optionsButton=Turbine.UI.Lotro.Button();
optionsButton:SetSize(250,20);
optionsButton:SetText("Ouvrir le panneau de configuration");
optionsButton:SetParent(optionsPanel);
optionsButton.MouseClick=function(sender,args)
	local optionDialog = GetConfigurationDialogInstance();
	optionDialog:SetVisible(true);
end
plugin.GetOptionsPanel = function( self )
  	return optionsPanel;
		
end

warbandsDialog = WarbandsDialog();
quickLauncher = QuickLauncher(warbandsDialog);
minimap = MiniMapWindow(warbandsDialog);

warbandsDialog.NotifyUpdate = function(sender, doneCount, total, justkilled, typeId)
	quickLauncher:NotifyUpdate(doneCount, total, justkilled, typeId);
end
quickLauncher:Start();

warbandsDialog:ReloadCdCounters();

Turbine.Shell.AddCommand( "WarbandsSlayer", RtmCommand );
