MiniMapViewer = class( Turbine.UI.Label );

function MiniMapViewer:Constructor(parent, canBeFocused, pos, dec)
	Turbine.UI.Label.Constructor( self );
	pos = pos or 1;
	dec = dec or 0;
	self:SetParent( parent );
	self.parent = parent;
	self:SetSize( 300, 200 );
	self:SetPosition( 0, 205*(pos-1)+dec );
	self:SetZOrder(-99);
	self:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 );	
	self:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	self:SetMouseVisible( false );
	self:SetText(value);
	
	self.mapFlag = Turbine.UI.Label(); 
	self.mapFlag:SetParent( self );
	self.mapFlag:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.mapFlag:SetSize(13, 16);
	self.mapFlag:SetBackground("WalmPlugins/WarbandsSlayer/resources/tdg_flag2.tga");	

	self.switchPointsVisibility = SwitchLabel(16, 16, "WalmPlugins/WarbandsSlayer/resources/filterButton.tga", "WalmPlugins/WarbandsSlayer/resources/filterButton2.tga");
	self.switchPointsVisibility:SetParent( self );
	self.switchPointsVisibility:SetPosition(2, self:GetHeight()-18);
	self.switchPointsVisibility:SetMouseVisible( true );
	self.switchPointsVisibility.tooltip = GenericTooltip(self.switchPointsVisibility, "Filtrer les Marques", "Permet d'afficher toutes les marques ou seulement celles pas découvertes.");
	self.switchPointsVisibility:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.switchPointsVisibility.Toggled = function(parent, pushed)
		for i=1, table.getn(self.localisationArray), 1 do
			local array = self.localisationArray[i];
			array:SetVisible(pushed==false or not array:IsPushed());
		end		
	end

	self.validateAllPoints = Turbine.UI.Label();
	self.validateAllPoints:SetParent( self );
	self.validateAllPoints:SetPosition(20, self:GetHeight()-18);
	self.validateAllPoints:SetSize(16, 16);
	self.validateAllPoints:SetMouseVisible( true );
	self.validateAllPoints:SetBackground("WalmPlugins/WarbandsSlayer/resources/validatepoi.jpg");
	self.validateAllPoints.tooltip = GenericTooltip(self.validateAllPoints, "Valider toutes les Marques", "Permet de valider d'un coup toutes les marques de la carte.");
	self.validateAllPoints:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.validateAllPoints.MouseClick = function(sender, args)
		if(PoiProgress==nil) then PoiProgress = {}; end;
		
		if(PoiProgress[self.warband.id]==nil) then PoiProgress[self.warband.id]={}; end;
		for i=1, table.getn(self.localisationArray), 1 do			
			local array = self.localisationArray[i];
			PoiProgress[self.warband.id][array.mData.id] = true;
			array:SetPushed(true);
		end		
		SavePOI(false);
		warbandsDialog:AddCooldown(self.warband, self.warband.name, true, true); 
	end

	self.validateQuest = Turbine.UI.Label();
	self.validateQuest:SetParent( self );
	self.validateQuest:SetPosition(2, self:GetHeight()-18);
	self.validateQuest:SetSize(16, 16);
	self.validateQuest:SetMouseVisible( true );
	self.validateQuest:SetBackground("WalmPlugins/WarbandsSlayer/resources/validatepoi.jpg");
	self.validateQuest.tooltip = GenericTooltip(self.validateQuest, "Indiquer la qu\195\170te comme faite", "Permet d'enregistrer la qu\195\170te comme faite, sans utiliser le detecteur auto.");
	self.validateQuest:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.validateQuest.MouseClick = function(sender, args)
		warbandsDialog:AddCooldown(nil, self.warband.name, true, true);
	end
	
	if(canBeFocused) then
		local selfView = Turbine.UI.Label();
		selfView:SetParent( self );
		selfView:SetPosition( self:GetWidth()-18, self:GetHeight()-18 );
		selfView:SetSize(16, 16);	
		selfView:SetBackground("WalmPlugins/WarbandsSlayer/resources/fullscreen.jpg");
		selfView:SetMouseVisible( true );
		selfView.tooltip = GenericTooltip(selfView, "Isoler la mini-map", "Permet de n'afficher que la mini-map.");
		selfView.MouseClick = function(sender, args)
			if(minimap:UpdateMap(self.warband, pos, self.areaData)~=nil) then
				warbandsDialog:SetVisible(false);
				minimap:SetVisible(true);
			end
		end	
	end
end

function MiniMapViewer:UpdateMap(warband, pos, areaData)
	
	if(warband==nil) then
		Turbine.Shell.WriteLine("<rgb=#FF5CCD>ERROR UpdateComponents gets nil warband</rgb>");
		return false;
	end
	if(areaData~=nil) then
		self.areaData = areaData;
	end
	self.warband = warband;
	if(self.localisationArray ~= nil) then
		while(table.getn(self.localisationArray) > 0) do
			local lab = table.remove(self.localisationArray);
			lab:SetParent(nil);
			lab.tooltip = nil;
			lab = nil;
		end
	end
	self.localisationArray = {};
	
	if(warband.map ~= nil) then
		self:SetBackground("WalmPlugins/WarbandsSlayer/resources/maps/"..warband.map);
	end
	local size = 16;
	if(warband.enemyType == 2 and Filters.tab==2) then
		self.mapFlag:SetVisible(false);
		self.switchPointsVisibility:SetVisible(false);
		self.validateQuest:SetVisible(true);
		self.validateAllPoints:SetVisible(false);
		if(warband.rovingThreatData~=nil and warband.rovingThreatData.loc~=nil) then
			for id=1, table.getn(warband.rovingThreatData.loc), 1 do
				local mData = warband.rovingThreatData.loc[id];
				-- k.m  k.c  k.l
				local coords = self:ComputeDynCoords(mData, self.areaData, 7);
				if(coords~=nil) then
					local mFlag = Turbine.UI.Label(); 
					mFlag:SetParent( self );
					mFlag:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
					mFlag:SetSize(13, 16);
					mFlag:SetBackground("WalmPlugins/WarbandsSlayer/resources/tdg_flag2.tga");	
					mFlag:SetPosition(coords.x,coords.y);
					table.insert(self.localisationArray, mFlag);
					mFlag.tooltip = GenericTooltip(mFlag, "Coordonn\195\169es : "..mData.c, mData.l or nil);
				end
			end
		else
			Turbine.Shell.WriteLine("<rgb=#FF0000>FORMAT ERROR : wb="..warband.id.." => warband.rovingThreatData.loc not found");
		end
	elseif((warband.poi~=nil or warband.multipoi~=nil) and Filters.tab==3) then
		self.mapFlag:SetVisible(false);
		self.switchPointsVisibility:SetVisible(true);
		self.validateAllPoints:SetVisible(true);
		self.validateQuest:SetVisible(false);
		local backgroundOn = "WalmPlugins/WarbandsSlayer/resources/chest.jpg";
		local backgroundOff = "WalmPlugins/WarbandsSlayer/resources/chestFound.jpg";
		
		if(warband.ico~=nil) then
			backgroundOn = "WalmPlugins/WarbandsSlayer/resources/"..warband.ico;
			backgroundOff = "WalmPlugins/WarbandsSlayer/resources/poiok.jpg";
			size = 12;
		end	
		local poiarray = warband.poi;
		local lAreaData = self.areaData;
		if(warband.multipoi~=nil) then
			poiarray = warband.multipoi[pos].poi;
			lAreaData = warband.multipoi[pos].c;
			self:SetBackground("WalmPlugins/WarbandsSlayer/resources/maps/"..warband.multipoi[pos].map);
		end
		if(lAreaData~=nil) then
			lAreaData.CoordsByPixelsX = (lAreaData.w - lAreaData.e)/300;
			lAreaData.CoordsByPixelsY = (lAreaData.s - lAreaData.n)/200;
			if(lAreaData.CoordsByPixelsX<0) then lAreaData.CoordsByPixelsX=0-lAreaData.CoordsByPixelsX; end
			if(lAreaData.CoordsByPixelsY<0) then lAreaData.CoordsByPixelsY=0-lAreaData.CoordsByPixelsY; end				
		end

		for id=1, table.getn(poiarray), 1 do
			local mData = poiarray[id];
			local coords = self:ComputeDynCoords(mData, lAreaData, size);
			if(coords~=nil) then
				local mFlag = SwitchLabel(size, size, backgroundOn, backgroundOff); 
				mFlag:SetParent( self );
				mFlag:SetPosition(coords.x,coords.y);
				mFlag.mData = mData;
				mFlag.Toggled = function(parent, pushed)
					if(PoiProgress==nil) then PoiProgress = {}; end;
					if(PoiProgress[warband.id]==nil) then PoiProgress[warband.id]={}; end;
					PoiProgress[warband.id][mData.id] = pushed;
					SavePOI(false);
					local completed = CheckPOICompletion(warband);
					warbandsDialog:AddCooldown(warband, warband.name, completed, completed);
					-- if(mFlag.tooltip~=nil) then mFlag.tooltip:SetVisible(false); mFlag.tooltip=nil; end
					-- mFlag.tooltip = GenericTooltip(mFlag, "Coordonn\195\169es : "..mData.c, mData.l);	
					-- if(pushed)then
						-- mFlag.tooltip:AddLayer("Déjà trouvé !", Turbine.UI.Color(0, 1, 0), nil, Turbine.UI.Lotro.Font.Verdana14);
					-- end	
				end
				local alreadyFound = false;
				if(PoiProgress~=nil and PoiProgress[warband.id]~=nil and PoiProgress[warband.id][mData.id]~=nil)then
					alreadyFound = PoiProgress[warband.id][mData.id];
				end
				mFlag:SetPushed(alreadyFound);				
				table.insert(self.localisationArray, mFlag);
				mFlag.tooltip = GenericTooltip(mFlag, "Coordonn\195\169es : "..mData.c, mData.l);	
				if(alreadyFound)then
					mFlag.tooltip:AddLayer("Déjà trouvé !", Turbine.UI.Color(0, 1, 0), nil, Turbine.UI.Lotro.Font.Verdana14);
				end
			end
		end				
	elseif(warband.mapPos ~= nil) then
		self.mapFlag:SetVisible(true);
		self.switchPointsVisibility:SetVisible(false);
		self.validateAllPoints:SetVisible(false);
		self.validateQuest:SetVisible(true);
		local coords = self:ComputeDynCoords(warband.mapPos, lAreaData, size);
		self.mapFlag:SetPosition(coords.x, coords.y);
		self.mapFlag.tooltip = GenericTooltip(mFlag, "Coordonn\195\169es : "..warband.loc, warband.closedPOI);
	end

	return true;
end

function MiniMapViewer:OnPOIUpdated(wad, poi)
	if(self.warband==nil or wad.id ~= self.warband.id) then return; end
	for i=1, table.getn(self.localisationArray), 1 do
		local cmp = self.localisationArray[i];
		if(cmp.mData.id == poi.id) then
			cmp:SetPushed(true);
		end
	end
end

function MiniMapViewer:ComputeDynCoords(mData, areaData, border)
	if(mData.x~=nil and mData.y~=nil) then
		return {x=mData.x-6, y=mData.y-8};
	elseif(mData.m~=nil) then
		return {x=mData.m.x-6, y=mData.m.y-8};
	elseif(mData.c~=nil and areaData~=nil) then
		local a, b, y1, y2, dir_y, x1, x2, dir_x = string.find(mData.c, "(%d*)%.(%d)([NnSs]), (%d*)%.(%d)([OoWwEe])");
		if(x1==nil or x2==nil or dir_x==nil or y1==nil or y2==nil or dir_y==nil) then
			if(Preferences.debug==true) then 
				Turbine.Shell.WriteLine("<rgb=#FF0000>ComputeDynCoords parsing ERROR : WB="..self.warband.id.." id="..mData.id);
			end
			return nil;
		end
		local cx = tonumber(x1)+tonumber(x2)/10;
		local cy = tonumber(y1)+tonumber(y2)/10;
		if(dir_y=="N" or dir_y=="n") then cy=0-cy; end		
		if(dir_x~="E" and dir_x~="e") then cx=0-cx; end
		local result = {x=(cx-areaData.w)/areaData.CoordsByPixelsX-6, y=(cy-areaData.n)/areaData.CoordsByPixelsY-8};
		if(result.x<0) then result.x=-2 end
		if(result.x>300-border) then result.x=300-border-2 end
		if(result.y<0) then result.y=-2 end
		if(result.y>200-border) then result.y=200-border-2 end
		-- Turbine.Shell.WriteLine("<rgb=#FF5CCD>"..mData.c.." ["..areaData.w..":"..areaData.n.."] ["..areaData.e..":"..areaData.s.."]");
		-- Turbine.Shell.WriteLine("<rgb=#FF5CCD>areaData.CoordsByPixelsX="..areaData.CoordsByPixelsX.."    areaData.CoordsByPixelsY="..areaData.CoordsByPixelsY);
		-- Turbine.Shell.WriteLine("<rgb=#FF5CCD>Point = "..cx..":"..cy.." => "..(cx-areaData.w)..":"..(cy-areaData.n).." => "..result.x..":"..result.y);
		-- Turbine.Shell.WriteLine("<rgb=#FF5CCD>=> "..result.x..":"..result.y);
		return result;
	elseif(Preferences.debug==true) then 
		Turbine.Shell.WriteLine("<rgb=#FF0000>ComputeDynCoords global ERROR : WB="..self.warband.id.." id="..mData.id);
	end
end

function MiniMapViewer:Unload()
	for i=1, table.getn(self.localisationArray), 1 do
		local array = self.localisationArray[i];
		array.tooltip:Free();
		array.tooltip = nil;
		array = nil;
	end
	if(self.mapFlag.tooltip~=nil) then 
		self.mapFlag.tooltip:SetVisible(false);	
		self.mapFlag.tooltip = nil;
	end
end