MiniMapWindow = class( Turbine.UI.Lotro.Window );

function MiniMapWindow:Constructor(parent)
	Turbine.UI.Lotro.Window.Constructor( self );
	
	self:SetSize( 300, 230 );
	self:SetVisible(false);
	self:SetText( "Minimap :)" );
	
	if(Preferences.minimap_x==nil or Preferences.minimap_y==nil) then
		Preferences.minimap_x = Preferences.main_x;
		Preferences.minimap_y = Preferences.main_y;
	end
	
	self:SetPosition(Preferences.minimap_x, Preferences.minimap_y);
	
	self.parent = parent;
	self.Closed = function(sender, args)
		self:Stop();
		if(parent~=nil) then
			--self.parentMap:UpdateMap(self.warband);
			parent:SetVisible(true);
		end
	end	
	
	self.PositionChanged = function(sender, args)
		Preferences.minimap_x, Preferences.minimap_y = self:GetPosition();
		SavePreferences();
	end	
	
	-- Hide UI when F12 is pressed, code copied from Chiran sources
	local hideUI = false;
	local wasVisible;
	self:SetWantsKeyEvents(true);
	self.KeyDown = function(sender, args)
		if (args.Action == 268435635) then
			if not hideUI then
				hideUI = true;
				if self:IsVisible() then
					wasVisible = true;
					self:SetVisible(false);					
				else
					wasVisible = false;
				end
				-- settingsWindow:SetVisible(false);
				-- toggleWindow:SetVisible(false);
			else
				hideUI = false;
				if wasVisible then
					self:SetVisible(true);
					-- settingsWindow:SetVisible(false);					
				end
				-- if (Settings.ToggleVisible == "yes") then
					-- toggleWindow:SetVisible(true);
				-- end
			end
		end
	end
	self.map = MiniMapViewer(self, false);
	self.map:SetPosition( 0, 28 );
end

function MiniMapWindow:UpdateMap(warband, pos, area)
	local result = self.map:UpdateMap(warband, pos, area);
	if result then
		self:SetText( warband.name );
	end
	return result;
end

function MiniMapWindow:OnPOIUpdated(wad, poi)
	if(self.map ~= nil) then self.map:OnPOIUpdated(wad, poi); end
end

function MiniMapWindow:IsRunning()
	return ( self ~= nil );
end

function MiniMapWindow:Stop()
	self = nil;
end